import './style.css';
import { defineComponent as $, ref as N, computed as m, resolveComponent as O, openBlock as d, createElementBlock as h, createElementVNode as f, withModifiers as V, normalizeClass as k, createTextVNode as C, toDisplayString as p, Fragment as q, renderList as K, withDirectives as B, createBlock as D, vShow as J, createCommentVNode as x, withKeys as w, normalizeStyle as A } from "vue";
const E = { class: "json-view-item" }, z = { key: 0 }, F = ["onClick", "aria-expanded"], L = { class: "properties" }, M = ["role", "tabindex"], T = { class: "value-key" }, _ = $({
  name: "json-view-item"
}), G = /* @__PURE__ */ Object.assign(_, {
  props: {
    data: {
      required: !0,
      type: Object
    },
    maxDepth: {
      type: Number,
      required: !1,
      default: 1
    },
    canSelect: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  emits: ["selected"],
  setup(e, { emit: i }) {
    const a = e, o = N(a.data.depth < a.maxDepth), g = () => {
      o.value = !o.value;
    }, u = (t) => {
      i("selected", {
        key: t.key,
        value: t.value,
        path: t.path
      });
    }, S = (t) => {
      i("selected", t);
    }, b = (t) => isNaN(t.key) ? '"' + t.key + '":' : t.key + ":", n = (t) => {
      switch (typeof t) {
        case "string":
          return { color: "var(--vjc-string-color)" };
        case "number":
          return { color: "var(--vjc-number-color)" };
        case "boolean":
          return { color: "var(--vjc-boolean-color)" };
        case "object":
          return { color: "var(--vjc-null-color)" };
        case "undefined":
          return { color: "var(--vjc-null-color)" };
        default:
          return { color: "var(--vjc-valueKey-color)" };
      }
    }, c = m(() => ({
      "chevron-arrow": !0,
      opened: o.value
    })), s = m(() => ({
      "value-key": !0,
      "can-select": a.canSelect
    })), l = m(() => a.data.type === "array" ? a.data.length === 1 ? a.data.length + " element" : a.data.length + " elements" : a.data.length === 1 ? a.data.length + " property" : a.data.length + " properties"), y = m(() => typeof a.data.value > "u" ? "undefined" : JSON.stringify(a.data.value));
    return (t, r) => {
      const j = O("json-view-item");
      return d(), h("div", E, [
        e.data.type === "object" || e.data.type === "array" ? (d(), h("div", z, [
          f("button", {
            onClick: V(g, ["stop"]),
            class: "data-key",
            "aria-expanded": o.value ? "true" : "false"
          }, [
            f("div", {
              class: k(c.value)
            }, null, 2),
            C(" " + p(e.data.key) + ": ", 1),
            f("span", L, p(l.value), 1)
          ], 8, F),
          (d(!0), h(q, null, K(e.data.children, (v) => B((d(), D(j, {
            onSelected: S,
            key: b(v),
            data: v,
            maxDepth: e.maxDepth,
            canSelect: e.canSelect
          }, null, 8, ["data", "maxDepth", "canSelect"])), [
            [J, o.value]
          ])), 128))
        ])) : x("", !0),
        e.data.type === "value" ? (d(), h("div", {
          key: 1,
          class: k(s.value),
          onClick: r[0] || (r[0] = (v) => u(e.data)),
          onKeyup: [
            r[1] || (r[1] = w((v) => u(e.data), ["enter"])),
            r[2] || (r[2] = w((v) => u(e.data), ["space"]))
          ],
          role: e.canSelect ? "button" : void 0,
          tabindex: e.canSelect ? "0" : void 0
        }, [
          f("span", T, p(e.data.key) + ":", 1),
          f("span", {
            style: A(n(e.data.value))
          }, p(y.value), 5)
        ], 42, M)) : x("", !0)
      ]);
    };
  }
});
const H = $({
  name: "json-view"
}), I = /* @__PURE__ */ Object.assign(H, {
  props: {
    data: {
      required: !0
    },
    rootKey: {
      type: String,
      required: !1,
      default: "root"
    },
    maxDepth: {
      type: Number,
      required: !1,
      default: 1
    },
    colorScheme: {
      type: String,
      required: !1,
      default: "light"
    }
  },
  emits: ["selected"],
  setup(e, { emit: i }) {
    const a = e, o = (n, c, s, l, y) => {
      if (g(c)) {
        let t = [];
        for (let [r, j] of Object.entries(c))
          t.push(
            o(
              r,
              j,
              s + 1,
              y ? `${l}${n}.` : `${l}`,
              !0
            )
          );
        return {
          key: n,
          type: "object",
          depth: s,
          path: l,
          length: t.length,
          children: t
        };
      } else if (u(c)) {
        let t = [];
        for (let r = 0; r < c.length; r++)
          t.push(
            o(
              r.toString(),
              c[r],
              s + 1,
              y ? `${l}${n}[${r}].` : `${l}`,
              !1
            )
          );
        return {
          key: n,
          type: "array",
          depth: s,
          path: l,
          length: t.length,
          children: t
        };
      } else
        return {
          key: n,
          type: "value",
          path: y ? l + n : l.slice(0, -1),
          depth: s,
          value: c
        };
    }, g = (n) => typeof n == "object" && n !== null && !u(n), u = (n) => Array.isArray(n), S = (n) => {
      i("selected", n);
    }, b = m(() => typeof a.data == "object" ? o(a.rootKey, { ...a.data }, 0, "", !0) : {
      key: a.rootKey,
      type: "value",
      path: "",
      depth: 0,
      value: a.data
    });
    return (n, c) => (d(), D(G, {
      class: k([{ "root-item": !0, dark: e.colorScheme === "dark" }]),
      data: b.value,
      maxDepth: e.maxDepth,
      onSelected: S
    }, null, 8, ["class", "data", "maxDepth"]));
  }
}), Q = {
  install: (e, i) => {
    e.component("JSONView", I);
  }
};
export {
  I as JSONView,
  Q as default
};
